#include <string.h>
#include "accdata.h"


aData::aData(char* _name, int _addr, int _val,int offset) {
	sprintf(name,"%s",_name);
	int x,y;
	getmaxyx(stdscr,y,x);
	tp = new_panel(newwin(ACC_WINDOW_LINES,ACC_WINDOW_COLS,y-CONSOLE_HEIGHT-6,offset*ACC_WINDOW_COLS));
	wbkgd(panel_window(tp),COLOR_PAIR(1));
	addr = _addr;
	value = _val;
	highlight = true;
	redrawWindow();
}

aData::~aData() {
	if (tp != NULL) {
		//delwin(panel_window(tp));
		del_panel(tp);
	}
}

void aData::resizeWindow(int y, int x,int offset) {
	WINDOW *old = panel_window(tp);
	replace_panel(tp,newwin(ACC_WINDOW_LINES,ACC_WINDOW_COLS,y-CONSOLE_HEIGHT-6,offset*ACC_WINDOW_COLS));
	delwin(old);
	redrawWindow();
}

void aData::redrawWindow() {
	wclear(panel_window(tp));
	if (highlight) {
		box(panel_window(tp),0,0);
		mvwprintw(panel_window(tp),0,0,"[%s]",name);
		wbkgd(panel_window(tp),COLOR_PAIR(1));
	} else {
		box(panel_window(tp),0,0);
		mvwprintw(panel_window(tp),0,0,"[%s]",name);
		wbkgd(panel_window(tp),COLOR_PAIR(7));
	}
	mvwprintw(panel_window(tp),1,1,"A:%d",addr);
	mvwprintw(panel_window(tp),2,1,"V:%d",value);
}

void aData::setHighlight(bool h) {
	highlight = h;
	redrawWindow();
}

void aData::toggle() {
	if (value == 0) value = 1;
	else value = 0;
	redrawWindow();
}

void aData::setValue(int val) {
	value = val;
	redrawWindow();
}
	
void aData::changeAddress(int _addr) {
	addr = _addr;
	redrawWindow();
}

