#include "configdialog.h"

configDialog::configDialog(char* svr, char* port,char* cos) {
	int x,y;
	getmaxyx(stdscr,y,x);
	trWin = newwin(7,40,y/2 - 3,x/2 - 20);
	trPanel = new_panel(trWin);
	wbkgd(trWin,COLOR_PAIR(5));

	trField[0] = new_field(1,16,1,20,0,0);
	trField[1] = new_field(1, 7,2,20,0,0);
	trField[2] = new_field(1, 3,3,20,0,0);
	trField[3] = NULL;

	set_field_back(trField[0], A_UNDERLINE);
	field_opts_off(trField[0], O_AUTOSKIP);
	set_field_buffer(trField[0],0,svr);
	set_field_back(trField[1], A_UNDERLINE);
	set_field_type(trField[1],TYPE_NUMERIC,0,0,65535);
	set_field_buffer(trField[1],0,port);
	field_opts_off(trField[1], O_AUTOSKIP);
	set_field_back(trField[2], A_UNDERLINE);
	field_opts_off(trField[2], O_AUTOSKIP);
	if (strlen(cos) == 0 || (strcmp(cos,"on") != 0 && strcmp(cos,"off") != 0)) sprintf(cos,"off");
	set_field_buffer(trField[2],0,cos);

	trForm = new_form(trField);
	set_form_win(trForm,trWin);
	post_form(trForm);

	box(trWin,0,0);	
	mvwprintw(trWin,0,1,"[configuration]");
	mvwprintw(trWin,1,2,"Server Address:");
	mvwprintw(trWin,2,2,"Port Number:");
	mvwprintw(trWin,3,2,"Connect on Start:");
	mvwprintw(trWin,5,2,"Changes will be saved on exit.");

	currentField = 0;

	form_driver(trForm,REQ_LEFT_CHAR);

}

configDialog::~configDialog() {
	//kill it.
    	unpost_form(trForm);
        free_form(trForm);
        for (int i=0;i<cFields;i++) free_field(trField[i]);	
	del_panel(trPanel);
}

char* configDialog::getFieldValue(int idx) {
	return strip(field_buffer(trField[idx],0)," ");
}

void configDialog::setFieldValue(int idx, char* val) {
	set_field_buffer(trField[idx],0,val);
}

bool configDialog::parseInput(int ch) {
	switch (ch) {
                                case KEY_LEFT:
					if (currentField == 2) {
						//toggle on/off
						if (strcmp(getFieldValue(2),"on") == 0) setFieldValue(2,"off");
						else setFieldValue(2,"on");
                                        } else form_driver(trForm,REQ_LEFT_CHAR);
                                        break;
                                case KEY_RIGHT:
                                        if (currentField == 2) {
						if (strcmp(getFieldValue(2),"on") == 0) setFieldValue(2,"off");
						else setFieldValue(2,"on");
                                        } else form_driver(trForm,REQ_RIGHT_CHAR);
                                        break;
                                case KEY_BACKSPACE:
                                        form_driver(trForm,REQ_LEFT_CHAR);
                                        form_driver(trForm,REQ_DEL_CHAR);
                                        break;
                                case 10:
                                        form_driver(trForm,REQ_FIRST_FIELD);
                                        return true;
                                case 9:
                                case KEY_DOWN:
					currentField += 1; if (currentField > 2) currentField = 0;
                                        form_driver(trForm,REQ_NEXT_FIELD);
                                        break;
                                case KEY_UP:
					currentField -= 1; if (currentField < 0) currentField = 2;
                                        form_driver(trForm,REQ_PREV_FIELD);
                                        break;
                                default:
                                        form_driver(trForm,ch);
                                        break;
	}
	return false;
}

