#include "traindialog.h"

trainDialog::trainDialog(tData* tr) {
	t = tr;

	int x,y;
	getmaxyx(stdscr,y,x);
       	trPanel = new_panel(newwin(7,33,(y/2)-4,(x/2)-15));
        wbkgd(panel_window(trPanel),COLOR_PAIR(2));

        char tmp[10];

        trField[0] = new_field(1,16,1,15,0,0);
        trField[1] = new_field(1, 5,2,15,0,0);
        trField[2] = new_field(1, 5,3,15,0,0);
        trField[3] = new_field(1, 5,4,15,0,0);
        trField[4] = NULL;

        set_field_back(trField[0], A_UNDERLINE);
        field_opts_off(trField[0], O_AUTOSKIP);
        if (t != NULL) set_field_buffer(trField[0],0,t->name);

        set_field_back(trField[1], A_UNDERLINE);
        set_field_type(trField[1],TYPE_NUMERIC,0,3,128);
        if (t != NULL) {
		sprintf(tmp,"%d",t->addr);
		set_field_buffer(trField[1],0,tmp);
	}
        field_opts_off(trField[1], O_AUTOSKIP);

        set_field_back(trField[2], A_UNDERLINE);
        set_field_type(trField[2],TYPE_NUMERIC,0,0,128);
        if (t != NULL) {
		sprintf(tmp,"%d",t->mspeed);
		set_field_buffer(trField[2],0,tmp);
	}
        field_opts_off(trField[2], O_AUTOSKIP);

        set_field_back(trField[3], A_UNDERLINE);
        set_field_type(trField[3],TYPE_NUMERIC,0,0,128);
        if (t != NULL) {
		sprintf(tmp,"%d",t->numf);
		set_field_buffer(trField[3],0,tmp);
	}
        field_opts_off(trField[3], O_AUTOSKIP);

        trForm = new_form(trField);
        set_form_win(trForm,panel_window(trPanel));
        post_form(trForm);


        box(panel_window(trPanel),0,0);
        mvwprintw(panel_window(trPanel),0,1,"[train config]");
        mvwprintw(panel_window(trPanel),1,2,"Train Name:");
        mvwprintw(panel_window(trPanel),2,2,"Address:");
        mvwprintw(panel_window(trPanel),3,2,"Max Speed:");
        mvwprintw(panel_window(trPanel),4,2,"Num Funcs:");

	form_driver(trForm,REQ_LEFT_CHAR);

}

trainDialog::~trainDialog() {
	//kill it.
    	unpost_form(trForm);
        free_form(trForm);
        for (int i=0;i<tFields;i++) free_field(trField[i]);	
	del_panel(trPanel);
}

char* trainDialog::getFieldValue(int idx) {
	return strip(field_buffer(trField[idx],0)," ");
}

void trainDialog::setFieldValue(int idx, char* val) {
	set_field_buffer(trField[idx],0,val);
}

void trainDialog::updateTrain() {
	strcpy(t->name,strip(getFieldValue(0)," "));
        t->addr = atoi(getFieldValue(1));
        t->mspeed = atoi(getFieldValue(2));
	t->setNFuncs(atoi(getFieldValue(3)));
	t->setSpeed(0);
	t->redrawWindow();
}

bool trainDialog::parseInput(int ch) {
	switch (ch) {
                                case KEY_LEFT:
                                        form_driver(trForm,REQ_LEFT_CHAR);
                                        break;
                                case KEY_RIGHT:
                                        form_driver(trForm,REQ_RIGHT_CHAR);
                                        break;
                                case KEY_BACKSPACE:
                                        form_driver(trForm,REQ_LEFT_CHAR);
                                        form_driver(trForm,REQ_DEL_CHAR);
                                        break;
                                case 10:
                                        form_driver(trForm,REQ_FIRST_FIELD);
                                        if (t != NULL) updateTrain();
                                        return true;
                                case 9:
                                case KEY_DOWN:
                                        form_driver(trForm,REQ_NEXT_FIELD);
                                        break;
                                case KEY_UP:
                                        form_driver(trForm,REQ_PREV_FIELD);
                                        break;
                                default:
                                        form_driver(trForm,ch);
                                        break;
	}
	return false;
}

